package apis

import (
    "fmt"

	"github.com/gin-gonic/gin"
	"github.com/go-admin-team/go-admin-core/sdk/api"
	"github.com/go-admin-team/go-admin-core/sdk/pkg/jwtauth/user"
	_ "github.com/go-admin-team/go-admin-core/sdk/pkg/response"

	"go-admin/app/admin/models"
	"go-admin/app/admin/service"
	"go-admin/app/admin/service/dto"
	"go-admin/common/actions"
)

type LinePreOrderStatus struct {
	api.Api
}

// GetPage 获取订单状态信息列表
// @Summary 获取订单状态信息列表
// @Description 获取订单状态信息列表
// @Tags 订单状态信息
// @Param pageSize query int false "页条数"
// @Param pageIndex query int false "页码"
// @Success 200 {object} response.Response{data=response.Page{list=[]models.LinePreOrderStatus}} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-pre-order-status [get]
// @Security Bearer
func (e LinePreOrderStatus) GetPage(c *gin.Context) {
    req := dto.LinePreOrderStatusGetPageReq{}
    s := service.LinePreOrderStatus{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
   	if err != nil {
   		e.Logger.Error(err)
   		e.Error(500, err, err.Error())
   		return
   	}

	p := actions.GetPermissionFromContext(c)
	list := make([]models.LinePreOrderStatus, 0)
	var count int64

	err = s.GetPage(&req, p, &list, &count)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取订单状态信息失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.PageOK(list, int(count), req.GetPageIndex(), req.GetPageSize(), "查询成功")
}

// Get 获取订单状态信息
// @Summary 获取订单状态信息
// @Description 获取订单状态信息
// @Tags 订单状态信息
// @Param id path int false "id"
// @Success 200 {object} response.Response{data=models.LinePreOrderStatus} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-pre-order-status/{id} [get]
// @Security Bearer
func (e LinePreOrderStatus) Get(c *gin.Context) {
	req := dto.LinePreOrderStatusGetReq{}
	s := service.LinePreOrderStatus{}
    err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	var object models.LinePreOrderStatus

	p := actions.GetPermissionFromContext(c)
	err = s.Get(&req, p, &object)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取订单状态信息失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.OK( object, "查询成功")
}

// Insert 创建订单状态信息
// @Summary 创建订单状态信息
// @Description 创建订单状态信息
// @Tags 订单状态信息
// @Accept application/json
// @Product application/json
// @Param data body dto.LinePreOrderStatusInsertReq true "data"
// @Success 200 {object} response.Response	"{"code": 200, "message": "添加成功"}"
// @Router /api/v1/line-pre-order-status [post]
// @Security Bearer
func (e LinePreOrderStatus) Insert(c *gin.Context) {
    req := dto.LinePreOrderStatusInsertReq{}
    s := service.LinePreOrderStatus{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }
	// 设置创建人
	req.SetCreateBy(user.GetUserId(c))

	err = s.Insert(&req)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("创建订单状态信息失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.OK(req.GetId(), "创建成功")
}

// Update 修改订单状态信息
// @Summary 修改订单状态信息
// @Description 修改订单状态信息
// @Tags 订单状态信息
// @Accept application/json
// @Product application/json
// @Param id path int true "id"
// @Param data body dto.LinePreOrderStatusUpdateReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "修改成功"}"
// @Router /api/v1/line-pre-order-status/{id} [put]
// @Security Bearer
func (e LinePreOrderStatus) Update(c *gin.Context) {
    req := dto.LinePreOrderStatusUpdateReq{}
    s := service.LinePreOrderStatus{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }
	req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Update(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("修改订单状态信息失败，\r\n失败信息 %s", err.Error()))
        return
	}
	e.OK( req.GetId(), "修改成功")
}

// Delete 删除订单状态信息
// @Summary 删除订单状态信息
// @Description 删除订单状态信息
// @Tags 订单状态信息
// @Param data body dto.LinePreOrderStatusDeleteReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "删除成功"}"
// @Router /api/v1/line-pre-order-status [delete]
// @Security Bearer
func (e LinePreOrderStatus) Delete(c *gin.Context) {
    s := service.LinePreOrderStatus{}
    req := dto.LinePreOrderStatusDeleteReq{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }

	// req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Remove(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("删除订单状态信息失败，\r\n失败信息 %s", err.Error()))
        return
	}
	e.OK( req.GetId(), "删除成功")
}
